unit Console;

(*///////////////////////////////////////////////////////////////////////
/////////    Console pour commande autres que celles implmentes  //////
/////////                     dans PRiSM                           //////
////////////////////////////////////////////////////////////////////////*) 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,COMM, ExtCtrls, IniFiles, ComCtrls, Utils;

type
  TFormConsole = class(TForm)
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PageConsole: TPageControl;
    Info: TTabSheet;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    VitesseStr: TEdit;
    GuideStr: TEdit;
    Pec_posi: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    PEC: TTabSheet;
    GroupBox7: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Panel_vitesse: TPanel;
    Panel_Index_Pec: TPanel;
    Panel_compteur_Pec: TPanel;
    Panel_prochaine_correction: TPanel;
    Panel24: TPanel;
    ButtonEnregistrerPEC: TButton;
    Panel23: TPanel;
    ButtonCHargerPEC: TButton;
    Panel22: TPanel;
    ButtonSauverPEC: TButton;
    Panel1: TPanel;
    ButtonEffacerMem: TButton;
    GroupBox1: TGroupBox;
    Panel_info_pec: TPanel;
    Focus: TTabSheet;
    Panel_Position: TPanel;
    Edit_Position: TEdit;
    Panel20: TPanel;
    Button_Focus_M: TButton;
    Panel21: TPanel;
    Button_Focus_P: TButton;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TrackBarFocus: TTrackBar;
    Panel2: TPanel;
    Button_Goto: TButton;
    Panel4: TPanel;
    Button_Reset: TButton;
    Panel6: TPanel;
    Panel7: TPanel;
    ButtonActiverPEC: TButton;
    Edit3: TEdit;
    procedure ButtonEnregistrerPECClick(Sender: TObject);
    procedure ButtonCHargerPECClick(Sender: TObject);
    procedure ButtonSauverPECClick(Sender: TObject);
    procedure ButtonParkClick(Sender: TObject);
    procedure ButtonSaveParkParamClick(Sender: TObject);
    procedure ButtonEffacerMemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button_GotoClick(Sender: TObject);
    procedure FOCUS_MOINS(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FOCUS_PLUS(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FOCUS_STOP(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button_ResetClick(Sender: TObject);
    procedure ButtonActiverPECClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormConsole: TFormConsole;
  Err_COM: Boolean;
  FocusRaw,FocusPosition,FocusInit,GMT_Park: longint;
  Focus_enabled: boolean;
  AH_Park,GAlpha_Park,GDelta_Park,long_Park:extended;
  ActiverPEC,DesactiverPEC,ChargerPEC,EffacerPEC,EnregistrerPEC,SauverPEC,GoPark,FocusCommand: boolean;
  FocusStr: string;

implementation

{$R *.DFM}

procedure TFormConsole.ButtonActiverPECClick(Sender: TObject);
begin
 if Panel_info_pec.caption = 'Correction MCMT des erreurs priodiques active' then
   DesactiverPEC := true
 else
   ActiverPEC := true;
end;

procedure TFormConsole.ButtonEnregistrerPECClick(Sender: TObject);

begin
 EnregistrerPEC := true;
end;

procedure TFormConsole.ButtonEffacerMemClick(Sender: TObject);

begin
 EffacerPEC := true;
end;

procedure TFormConsole.ButtonCHargerPECClick(Sender: TObject);

begin
  ChargerPEC := true;
end;


procedure TFormConsole.ButtonSauverPECClick(Sender: TObject);

begin
  SauverPEC := true;
end;

procedure TFormConsole.ButtonParkClick(Sender: TObject);

Var
  DeviceIni: TIniFile;
  ValPark_AD,ValPark_DEC: double;
  MoveStepsAlpha,MoveStepsDelta : integer;
  Alpha,Alphatemp,Deltatemp: double;
  MMSB,MSB,LSB,LLSB: byte;
  astring: shortstring;
  Resol_AD,Resol_DEC : longint;

begin
 DeviceIni := TIniFile.Create('mcmtii.ini');
   with DeviceIni do
   begin
    WriteBool('ParkMode','Park',True);
    ValPark_AD:=Readfloat('ParkMode','AH',0);
    ValPark_DEC:=Readfloat('ParkMode','DEC',0);
    Resol_AD:= ReadInteger('Parameters', 'Resol_AD', 4608000);
    Resol_DEC:= ReadInteger('Parameters', 'Resol_DEC', 4608000);
   end;
 DeviceIni.free;

 Deltatemp := ValPark_DEC - GDelta_PARK;

 MoveStepsDelta := round(Resol_DEC * DeltaTemp / (2*Pi));

 Alpha := HeureSiderale(long_Park,GMT_Park) - ValPark_AD;

 if Alpha > 2*pi then Alpha := Alpha - 2*pi;

 //showmessage('Alpha = ' + floattostr(Alpha));

 AlphaTemp := GAlpha_Park;                      //Position actuelle;

 if Alpha - Pi > GAlpha_Park then
  AlphaTemp := AlphaTemp + 2*Pi
 else
  if GAlpha_Park - Pi > Alpha then
   Alpha := Alpha + 2*Pi;

 AlphaTemp := AlphaTemp - Alpha;

 MoveStepsAlpha := round(Resol_AD * AlphaTemp / (2*Pi));

 while not AccesComAllowance(NumCOM) do;
 AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);
   try
     //Alpha et Delta sont en RADIANS !!!

     if (abs(MoveStepsDelta) > 0) then
      begin
        MMSB:= (abs(MoveStepsDelta) SHR 24) and $7F;
        MSB:= (abs(MoveStepsDelta) SHR 16) and $FF;
        LSB:= (abs(MoveStepsDelta) SHR 8) and $FF;
        LLSB:= abs(MoveStepsDelta) and $FF;
        if MoveStepsDelta < 0 then MMSB := MMSB or $80;

        while deviceready(1) <> 1 do Application.ProcessMessages;
        astring:='p'+chr(MMSB)+chr(MSB)+chr(LSB)+chr(LLSB);
        sendcommand(astring,0,1);
      end;

     if (abs(MoveStepsAlpha) > 0) then
      begin

        MMSB:= (abs(MoveStepsAlpha) SHR 24) and $7F;
        MSB:= (abs(MoveStepsAlpha) SHR 16) and $FF;
        LSB:= (abs(MoveStepsAlpha) SHR 8) and $FF;
        LLSB:= abs(MoveStepsAlpha) and $FF;
        if MoveStepsAlpha < 0 then MMSB := MMSB or $80;

        while deviceready(0) <> 1 do Application.ProcessMessages;
        astring:='P'+chr(0)+chr(0)+chr(0)+chr(0);                      // Commande Park
        sendcommand(astring,0,0);
        while deviceready(0) <> 1 do Application.ProcessMessages;
        astring:='p'+chr(MMSB)+chr(MSB)+chr(LSB)+chr(LLSB);            // Commande Positionnement
        sendcommand(astring,0,0);
      end;

   finally
     Closehandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TFormConsole.ButtonSaveParkParamClick(Sender: TObject);

Var
 DeviceIni: TIniFile;
 astring: shortstring;

begin
 DeviceIni := TIniFile.Create('mcmtii.ini');
   with DeviceIni do
   begin
    WriteBool('ParkMode','Park',True);
    Writefloat('ParkMode','AH',AH_Park);
    Writefloat('ParkMode','DEC',GDelta_PARK);
   end;
 DeviceIni.free;

 GoPark := true;

end;

procedure TFormConsole.FormShow(Sender: TObject);
begin
 PageCOnsole.ActivePageIndex := 0;
 if focus_enabled then FormConsole.Focus.visible := true
  else FormConsole.Focus.visible := false;
end;

procedure TFormConsole.Button_GotoClick(Sender: TObject);

Var
   NumOfSteps : longint;
   astring:ShortString;
   MMSB,MSB,LSB,LLSB: byte;
   Err_COM:Boolean;

Begin
 NumOfSteps := strtoint(Edit_Position.Text) - FocusPosition;
 MMSB:= (abs(NumOfSteps) SHR 24) and $FF;
 MSB:= (abs(NumOfSteps) SHR 16) and $FF;
 LSB:= (abs(NumOfSteps) SHR 8) and $FF;
 LLSB:= abs(NumOfSteps) and $FF;
 if NumOfSteps < 0 then MMSB := MMSB or $80;
 FocusStr:='p'+chr(MMSB)+chr(MSB)+chr(LSB)+chr(LLSB);
 FocusCommand := true;
end;

procedure TFormConsole.FOCUS_MOINS(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 case TrackBarFocus.Position of
                        3:   begin   //Fournir la vitesse VMax :
                                 FocusStr:='W'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
                        2:begin        //Fournir la vitesse VMed :
                                 FocusStr:='F'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
                        1:begin     // Fournir la vitesse VMin :
                                 FocusStr:='Q'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
 end;
 FocusCommand := true;
end;

procedure TFormConsole.FOCUS_PLUS(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 case TrackBarFocus.Position of
                        3:   begin   //Fournir la vitesse VMax :
                                 FocusStr:='X'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
                        2:begin        //Fournir la vitesse VMed :
                                 FocusStr:='G'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
                        1:begin     // Fournir la vitesse VMin :
                                 FocusStr:='D'+chr(0)+chr(0)+chr(0)+chr(0);
                                end;
 end;
 FocusCommand := true;
end;

procedure TFormConsole.FOCUS_STOP(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 case TrackBarFocus.Position of
                        3: FocusStr:= 'StopSlewing';
                        2: FocusStr:= 'StopSlewing';
                        1: FocusStr:='S'+chr(0)+chr(0)+chr(0)+chr(0);
 end;
 FocusCommand := true;
end;

procedure TFormConsole.Button_ResetClick(Sender: TObject);
begin
 FocusInit := FocusRaw;
end;

end.
